﻿namespace Controls
{
    using HTMLConverter;
    using System;
    using System.IO;
    using System.Text;
    using System.Windows;
    using System.Windows.Documents;

    public class HtmlFormatter : ITextFormatter
    {
        public string GetText(FlowDocument document)
        {
            TextRange range = new TextRange(document.ContentStart, document.ContentEnd);
            using (MemoryStream stream = new MemoryStream())
            {
                range.Save(stream, DataFormats.Xaml);
                return HtmlFromXamlConverter.ConvertXamlToHtml(Encoding.Default.GetString(stream.ToArray()));
            }
        }

        public void SetText(FlowDocument document, string text)
        {
            text = HtmlToXamlConverter.ConvertHtmlToXaml(text, false);
            try
            {
                TextRange range = new TextRange(document.ContentStart, document.ContentEnd);
                using (MemoryStream stream = new MemoryStream(Encoding.UTF8.GetBytes(text)))
                {
                    range.Load(stream, DataFormats.Xaml);
                }
            }
            catch
            {
                throw new InvalidDataException("data provided is not in the correct Html format.");
            }
        }
    }
}

