﻿namespace Controls
{
    using RecordLink;
    using System;
    using System.Collections.ObjectModel;
    using System.ComponentModel;
    using System.Diagnostics;
    using System.Windows;
    using System.Windows.Controls;
    using System.Windows.Data;
    using System.Windows.Documents;
    using System.Windows.Forms;
    using System.Windows.Input;
    using System.Windows.Markup;
    using System.Windows.Media;

    public class MyNotes : System.Windows.Controls.UserControl, IComponentConnector, IStyleConnector
    {
        private bool _contentLoaded;
        private SortAdorner _CurAdorner = null;
        private GridViewColumnHeader _CurSortCol = null;
        private string _myEmail;
        private ObservableCollection<NAVRecordLink> _myNotifications = new ObservableCollection<NAVRecordLink>();
        private string cellToCopy;
        private int currentHeight;
        private NAVRecordLink currentLink;
        internal System.Windows.Controls.ListView listView1;
        public static RoutedCommand MyCommand = new RoutedCommand();
        public Delegate userControlPointer;
        public Delegate userFunctionPointer;

        public MyNotes()
        {
            this.InitializeComponent();
            MyCommand.InputGestures.Add(new KeyGesture(Key.C, ModifierKeys.Shift | ModifierKeys.Control));
        }

        [DebuggerNonUserCode]
        internal Delegate _CreateDelegate(System.Type delegateType, string handler)
        {
            return Delegate.CreateDelegate(delegateType, this, handler);
        }

        public void Add(NAVRecordLink link)
        {
            foreach (NAVRecordLink link2 in this._myNotifications)
            {
                if (link.linkID.Equals(link2.linkID))
                {
                    return;
                }
            }
            this._myNotifications.Add(link);
        }

        public void Clear()
        {
        }

        private void CommandCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = true;
        }

        private void CommandExecuted(object sender, ExecutedRoutedEventArgs e)
        {
            this.CopyRows();
        }

        private void ContextMenu_PreviewMouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
        }

        private void CopyRows()
        {
            try
            {
                GridView view = this.listView1.View as GridView;
                string text = "";
                text = text + "From\tCreated Date\tNote\tPage" + Environment.NewLine;
                for (int i = 0; i < this.listView1.SelectedItems.Count; i++)
                {
                    NAVRecordLink link = (NAVRecordLink) this.listView1.SelectedItems[i];
                    if (link != null)
                    {
                        string str2 = text;
                        text = str2 + link.from + "\t" + link.date + "\t" + link.note + "\t" + link.page + Environment.NewLine;
                    }
                }
                System.Windows.Clipboard.SetText(text);
            }
            catch (Exception)
            {
            }
        }

        [DebuggerNonUserCode]
        public void InitializeComponent()
        {
            if (!this._contentLoaded)
            {
                this._contentLoaded = true;
                Uri resourceLocator = new Uri("/NAVEnhancedNotesCustomControls;component/mynotes.xaml", UriKind.Relative);
                System.Windows.Application.LoadComponent(this, resourceLocator);
            }
        }

        private void listView1_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            DependencyObject originalSource = (DependencyObject) e.OriginalSource;
            this.OpenPage(originalSource);
        }

        private void listView1_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
        }

        private void listView1_MouseRightButtonUp(object sender, MouseButtonEventArgs e)
        {
            try
            {
                if (e.OriginalSource is TextBlock)
                {
                    TextBlock originalSource = e.OriginalSource as TextBlock;
                    this.cellToCopy = originalSource.Text;
                }
                this.currentLink = (NAVRecordLink) this.listView1.SelectedItem;
                this.userFunctionPointer.DynamicInvoke(new object[] { this.currentLink });
            }
            catch (Exception exception)
            {
                System.Windows.Forms.MessageBox.Show(exception.Message);
            }
        }

        private void MenuItem_Click_CopyCell(object sender, RoutedEventArgs e)
        {
            System.Windows.Clipboard.SetText(this.cellToCopy);
        }

        private void MenuItem_Click_CopyRows(object sender, RoutedEventArgs e)
        {
            this.CopyRows();
        }

        private void MenuItem_Click_CreateOutlookTask(object sender, RoutedEventArgs e)
        {
            OutlookHelper.CreateOutlookTask(this.currentLink, this._myEmail);
        }

        private void MenuItem_Click_OpenPage(object sender, RoutedEventArgs e)
        {
            try
            {
                Process.Start(this.currentLink.URL);
            }
            catch (Exception)
            {
            }
        }

        private void MenuItem_Click_RemoveNote(object sender, RoutedEventArgs e)
        {
            this.RemoveNote();
        }

        private void MenuItem_Click_SetHeader1(object sender, RoutedEventArgs e)
        {
            try
            {
                GridViewColumnHeader header;
                System.Windows.Controls.MenuItem item = (System.Windows.Controls.MenuItem) this.listView1.ContextMenu.Items[7];
                System.Windows.Controls.MenuItem item2 = (System.Windows.Controls.MenuItem) item.Items[0];
                System.Windows.Controls.MenuItem item3 = (System.Windows.Controls.MenuItem) item.Items[1];
                System.Windows.Controls.MenuItem item4 = (System.Windows.Controls.MenuItem) item.Items[2];
                GridView view = this.listView1.View as GridView;
                double actualHeight = 0.0;
                if (this.currentHeight == 1)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight;
                }
                else if (this.currentHeight == 2)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight / 2.0;
                }
                else if (this.currentHeight == 3)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight / 3.0;
                }
                else
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight;
                }
                double num2 = actualHeight;
                for (int i = 0; i < view.Columns.Count; i++)
                {
                    header = view.Columns[i].Header as GridViewColumnHeader;
                    header.Height = num2;
                }
                item2.IsChecked = true;
                item3.IsChecked = false;
                item4.IsChecked = false;
                this.currentHeight = 1;
            }
            catch (Exception exception)
            {
                System.Windows.Forms.MessageBox.Show(exception.Message);
            }
        }

        private void MenuItem_Click_SetHeader2(object sender, RoutedEventArgs e)
        {
            try
            {
                GridViewColumnHeader header;
                System.Windows.Controls.MenuItem item = (System.Windows.Controls.MenuItem) this.listView1.ContextMenu.Items[7];
                System.Windows.Controls.MenuItem item2 = (System.Windows.Controls.MenuItem) item.Items[0];
                System.Windows.Controls.MenuItem item3 = (System.Windows.Controls.MenuItem) item.Items[1];
                System.Windows.Controls.MenuItem item4 = (System.Windows.Controls.MenuItem) item.Items[2];
                GridView view = this.listView1.View as GridView;
                double actualHeight = 0.0;
                if (this.currentHeight == 1)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight;
                }
                else if (this.currentHeight == 2)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight / 2.0;
                }
                else if (this.currentHeight == 3)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight / 3.0;
                }
                else
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight;
                }
                double num2 = actualHeight * 2.0;
                for (int i = 0; i < view.Columns.Count; i++)
                {
                    header = view.Columns[i].Header as GridViewColumnHeader;
                    header.Height = num2;
                }
                item2.IsChecked = false;
                item3.IsChecked = true;
                item4.IsChecked = false;
                this.currentHeight = 2;
            }
            catch (Exception exception)
            {
                System.Windows.Forms.MessageBox.Show(exception.Message);
            }
        }

        private void MenuItem_Click_SetHeader3(object sender, RoutedEventArgs e)
        {
            try
            {
                GridViewColumnHeader header;
                System.Windows.Controls.MenuItem item = (System.Windows.Controls.MenuItem) this.listView1.ContextMenu.Items[7];
                System.Windows.Controls.MenuItem item2 = (System.Windows.Controls.MenuItem) item.Items[0];
                System.Windows.Controls.MenuItem item3 = (System.Windows.Controls.MenuItem) item.Items[1];
                System.Windows.Controls.MenuItem item4 = (System.Windows.Controls.MenuItem) item.Items[2];
                GridView view = this.listView1.View as GridView;
                double actualHeight = 0.0;
                if (this.currentHeight == 1)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight;
                }
                else if (this.currentHeight == 2)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight / 2.0;
                }
                else if (this.currentHeight == 3)
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight / 3.0;
                }
                else
                {
                    header = view.Columns[0].Header as GridViewColumnHeader;
                    actualHeight = header.ActualHeight;
                }
                double num2 = actualHeight * 3.0;
                for (int i = 0; i < view.Columns.Count; i++)
                {
                    header = view.Columns[i].Header as GridViewColumnHeader;
                    header.Height = num2;
                }
                item2.IsChecked = false;
                item3.IsChecked = false;
                item4.IsChecked = true;
                this.currentHeight = 3;
            }
            catch (Exception exception)
            {
                System.Windows.Forms.MessageBox.Show(exception.Message);
            }
        }

        private void MenuItem_Click_ViewNote(object sender, RoutedEventArgs e)
        {
            FullNoteWindow window = new FullNoteWindow();
            NotesTextBlock element = new NotesTextBlock {
                MyEmail = this._myEmail,
                link = this.currentLink
            };
            element.CreateLargeNote();
            element.Width = window.stackPanel1.Width;
            element.Height = window.stackPanel1.Height;
            window.stackPanel1.Children.Add(element);
            window.Show();
        }

        private void OpenPage(DependencyObject dep)
        {
            try
            {
                while ((dep != null) && !(dep is System.Windows.Controls.ListViewItem))
                {
                    dep = VisualTreeHelper.GetParent(dep);
                }
                if (dep != null)
                {
                    NAVRecordLink link = (NAVRecordLink) this.listView1.ItemContainerGenerator.ItemFromContainer(dep);
                    Process.Start(link.URL);
                }
            }
            catch (Exception)
            {
            }
        }

        protected virtual void RemoveNote()
        {
            object[] args = new object[2];
            this.userControlPointer.DynamicInvoke(args);
            this._myNotifications.Remove(this.currentLink);
        }

        public void SetColumnWidth()
        {
            GridView view = this.listView1.View as GridView;
            Decorator child = VisualTreeHelper.GetChild(this.listView1, 0) as Decorator;
            if (child != null)
            {
                ScrollViewer viewer = child.Child as ScrollViewer;
                if (viewer != null)
                {
                    ItemsPresenter content = viewer.Content as ItemsPresenter;
                    if (content != null)
                    {
                        double actualWidth = content.ActualWidth;
                        for (int i = 0; i < view.Columns.Count; i++)
                        {
                            if (i == 2)
                            {
                                i++;
                            }
                            actualWidth -= view.Columns[i].ActualWidth;
                        }
                        view.Columns[2].Width = actualWidth - 10.0;
                    }
                }
            }
        }

        public void SetSize(double w, double h)
        {
            this.listView1.Width = w;
            this.listView1.Height = h;
            base.Width = w;
            base.Height = h;
            this.SetColumnWidth();
        }

        private void SortClick(object sender, RoutedEventArgs e)
        {
            GridViewColumnHeader header = sender as GridViewColumnHeader;
            string tag = header.Tag as string;
            if (this._CurSortCol != null)
            {
                AdornerLayer.GetAdornerLayer(this._CurSortCol).Remove(this._CurAdorner);
                this.listView1.Items.SortDescriptions.Clear();
            }
            ListSortDirection ascending = ListSortDirection.Ascending;
            if ((this._CurSortCol == header) && (this._CurAdorner.Direction == ascending))
            {
                ascending = ListSortDirection.Descending;
            }
            this._CurSortCol = header;
            this._CurAdorner = new SortAdorner(this._CurSortCol, ascending);
            AdornerLayer.GetAdornerLayer(this._CurSortCol).Add(this._CurAdorner);
            CollectionViewSource.GetDefaultView(this.listView1.ItemsSource).SortDescriptions.Add(new SortDescription(tag, ascending));
            this.listView1.Items.Refresh();
        }

        [EditorBrowsable(EditorBrowsableState.Never), DebuggerNonUserCode]
        void IComponentConnector.Connect(int connectionId, object target)
        {
            switch (connectionId)
            {
                case 1:
                    ((CommandBinding) target).Executed += new ExecutedRoutedEventHandler(this.CommandExecuted);
                    return;

                case 2:
                    this.listView1 = (System.Windows.Controls.ListView) target;
                    this.listView1.MouseDoubleClick += new MouseButtonEventHandler(this.listView1_MouseDoubleClick);
                    this.listView1.MouseRightButtonDown += new MouseButtonEventHandler(this.listView1_MouseRightButtonDown);
                    this.listView1.MouseRightButtonUp += new MouseButtonEventHandler(this.listView1_MouseRightButtonUp);
                    return;

                case 4:
                    ((System.Windows.Controls.ContextMenu) target).PreviewMouseRightButtonDown += new MouseButtonEventHandler(this.ContextMenu_PreviewMouseRightButtonDown);
                    return;

                case 5:
                    ((System.Windows.Controls.MenuItem) target).Click += new RoutedEventHandler(this.MenuItem_Click_CopyCell);
                    return;

                case 6:
                    ((System.Windows.Controls.MenuItem) target).Click += new RoutedEventHandler(this.MenuItem_Click_CopyRows);
                    return;

                case 7:
                    ((System.Windows.Controls.MenuItem) target).Click += new RoutedEventHandler(this.MenuItem_Click_OpenPage);
                    return;

                case 8:
                    ((System.Windows.Controls.MenuItem) target).Click += new RoutedEventHandler(this.MenuItem_Click_ViewNote);
                    return;

                case 9:
                    ((System.Windows.Controls.MenuItem) target).Click += new RoutedEventHandler(this.MenuItem_Click_RemoveNote);
                    return;

                case 10:
                    ((System.Windows.Controls.MenuItem) target).Click += new RoutedEventHandler(this.MenuItem_Click_CreateOutlookTask);
                    return;
            }
            this._contentLoaded = true;
        }

        [EditorBrowsable(EditorBrowsableState.Never), DebuggerNonUserCode]
        void IStyleConnector.Connect(int connectionId, object target)
        {
            if (connectionId == 3)
            {
                EventSetter item = new EventSetter {
                    Event = UIElement.PreviewMouseRightButtonDownEvent,
                    Handler = new MouseButtonEventHandler(this.ContextMenu_PreviewMouseRightButtonDown)
                };
                ((Style) target).Setters.Add(item);
            }
        }

        public string MyEmail
        {
            get
            {
                return this._myEmail;
            }
            set
            {
                this._myEmail = value;
            }
        }

        public ObservableCollection<NAVRecordLink> MyNotifications
        {
            get
            {
                return this._myNotifications;
            }
        }
    }
}

