﻿namespace Controls
{
    using RecordLink;
    using System;
    using System.ComponentModel;
    using System.Diagnostics;
    using System.Runtime.InteropServices;
    using System.Windows;
    using System.Windows.Controls;
    using System.Windows.Input;
    using System.Windows.Markup;
    using System.Windows.Media;

    public class NotesTextBlock : UserControl, IComponentConnector
    {
        private bool _contentLoaded;
        private NAVRecordLink _link;
        private string _myEmail;
        private long LastTicks = 0L;
        private NoteSize size;
        internal Controls.RichTextBox textBlock1;

        public NotesTextBlock()
        {
            this.InitializeComponent();
            this.textBlock1.TextFormatter = new HtmlFormatter();
        }

        [DebuggerNonUserCode]
        internal Delegate _CreateDelegate(Type delegateType, string handler)
        {
            return Delegate.CreateDelegate(delegateType, this, handler);
        }

        private void CreateBaseNote()
        {
            string note;
            this.textBlock1.MouseLeftButtonDown += new MouseButtonEventHandler(this.tb_MouseLeftButtonDown);
            this.textBlock1.MouseRightButtonDown += new MouseButtonEventHandler(this.textBlock1_MouseRightButtonDown);
            if (this._link.RTFNote.StartsWith("<HTML><BODY>"))
            {
                note = this._link.RTFNote.Substring(12);
                if (note.Contains("<P>"))
                {
                    note = note.Remove(note.IndexOf("<P>"), 3);
                    note = note.Remove(note.IndexOf("</P>"), 4);
                }
                this.textBlock1.Text = "<HTML><BODY><B>From:</B> " + this._link.from;
                if (this._link.to != "")
                {
                    this.textBlock1.Text = this.textBlock1.Text + " <B>To:</B> " + this._link.to;
                }
                this.textBlock1.Text = this.textBlock1.Text + " <B>Date:</B> " + this._link.date + note;
            }
            else
            {
                note = this._link.note;
                this.textBlock1.Text = "<HTML><BODY><B>From:</B> " + this._link.from;
                if (this._link.to != "")
                {
                    this.textBlock1.Text = this.textBlock1.Text + " <B>To:</B> " + this._link.to;
                }
                string text = this.textBlock1.Text;
                this.textBlock1.Text = text + " <B>Date:</B> " + this._link.date + "<DIV STYLE=\"text-align:Left;font-family:Segoe UI;font-style:normal;font-weight:normal;font-size:12;color:#000000;\"><SPAN>" + note + "</SPAN></DIV></BODY></HTML>";
            }
        }

        public void CreateLargeNote()
        {
            if (this._link != null)
            {
                this.CreateBaseNote();
            }
            else
            {
                this.textBlock1.Focusable = false;
            }
            this.size = NoteSize.Large;
            this.textBlock1.Height = 505.0;
            this.textBlock1.Width = 457.0;
        }

        public void CreateMyNote()
        {
        }

        public void CreateSmallNote()
        {
            if (this._link != null)
            {
                this.CreateBaseNote();
            }
            else
            {
                this.textBlock1.Focusable = false;
            }
            this.textBlock1.MinHeight = 80.0;
            this.size = NoteSize.Small;
        }

        [DllImport("user32.dll")]
        private static extern bool HideCaret(IntPtr hWnd);
        [DebuggerNonUserCode]
        public void InitializeComponent()
        {
            if (!this._contentLoaded)
            {
                this._contentLoaded = true;
                Uri resourceLocator = new Uri("/NAVEnhancedNotesCustomControls;component/notestextblock.xaml", UriKind.Relative);
                Application.LoadComponent(this, resourceLocator);
            }
        }

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
        }

        private void MenuItem_Click_CreateOutlookTask(object sender, RoutedEventArgs e)
        {
            OutlookHelper.CreateOutlookTask(this.link, this.MyEmail);
        }

        public void SetSize(double w, double h)
        {
            this.textBlock1.Width = w;
            base.Width = w;
        }

        [DebuggerNonUserCode, EditorBrowsable(EditorBrowsableState.Never)]
        void IComponentConnector.Connect(int connectionId, object target)
        {
            switch (connectionId)
            {
                case 1:
                    this.textBlock1 = (Controls.RichTextBox) target;
                    break;

                case 2:
                    ((MenuItem) target).Click += new RoutedEventHandler(this.MenuItem_Click_CreateOutlookTask);
                    break;

                default:
                    this._contentLoaded = true;
                    break;
            }
        }

        private void tb_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (this.size == NoteSize.Small)
            {
                if ((DateTime.Now.Ticks - this.LastTicks) < 0x2dc6c0L)
                {
                    FullNoteWindow window = new FullNoteWindow();
                    NotesTextBlock element = new NotesTextBlock {
                        MyEmail = this._myEmail,
                        link = this._link
                    };
                    element.CreateLargeNote();
                    element.Width = window.stackPanel1.Width;
                    element.Height = window.stackPanel1.Height;
                    window.stackPanel1.Children.Add(element);
                    window.Show();
                }
                this.LastTicks = DateTime.Now.Ticks;
            }
        }

        private void textBlock1_GotFocus(object sender, RoutedEventArgs e)
        {
            this.textBlock1.Background = Brushes.LightCyan;
        }

        private void textBlock1_LostFocus(object sender, RoutedEventArgs e)
        {
            this.textBlock1.Background = Brushes.White;
        }

        private void textBlock1_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
        }

        public NAVRecordLink link
        {
            get
            {
                return this._link;
            }
            set
            {
                this._link = value;
            }
        }

        public string MyEmail
        {
            get
            {
                return this._myEmail;
            }
            set
            {
                this._myEmail = value;
            }
        }

        private enum NoteSize
        {
            Small,
            Large
        }
    }
}

