﻿namespace Controls
{
    using System;
    using System.IO;
    using System.Text;
    using System.Windows;
    using System.Windows.Documents;

    public class RtfFormatter : ITextFormatter
    {
        public string GetText(FlowDocument document)
        {
            TextRange range = new TextRange(document.ContentStart, document.ContentEnd);
            using (MemoryStream stream = new MemoryStream())
            {
                range.Save(stream, DataFormats.Rtf);
                return Encoding.Default.GetString(stream.ToArray());
            }
        }

        public void SetText(FlowDocument document, string text)
        {
            TextRange range = new TextRange(document.ContentStart, document.ContentEnd);
            using (MemoryStream stream = new MemoryStream(Encoding.ASCII.GetBytes(text)))
            {
                range.Load(stream, DataFormats.Rtf);
            }
        }
    }
}

