﻿namespace Controls
{
    using System;
    using System.IO;
    using System.Text;
    using System.Windows;
    using System.Windows.Documents;

    public class XamlFormatter : ITextFormatter
    {
        public string GetText(FlowDocument document)
        {
            TextRange range = new TextRange(document.ContentStart, document.ContentEnd);
            using (MemoryStream stream = new MemoryStream())
            {
                range.Save(stream, DataFormats.Xaml);
                return Encoding.Default.GetString(stream.ToArray());
            }
        }

        public void SetText(FlowDocument document, string text)
        {
            try
            {
                TextRange range = new TextRange(document.ContentStart, document.ContentEnd);
                using (MemoryStream stream = new MemoryStream(Encoding.ASCII.GetBytes(text)))
                {
                    range.Load(stream, DataFormats.Xaml);
                }
            }
            catch
            {
                throw new InvalidDataException("data provided is not in the correct Xaml format.");
            }
        }
    }
}

