﻿using System;
using System.Text.RegularExpressions;

public static class HtmlRemoval
{
    private static Regex _htmlRegex = new Regex("<.*?>", RegexOptions.Compiled);

    public static string StripTagsCharArray(string source)
    {
        char[] chArray = new char[source.Length];
        int index = 0;
        bool flag = false;
        for (int i = 0; i < source.Length; i++)
        {
            char ch = source[i];
            if (ch == '<')
            {
                flag = true;
            }
            else if (ch == '>')
            {
                flag = false;
            }
            else if (!flag)
            {
                chArray[index] = ch;
                index++;
            }
        }
        return new string(chArray, 0, index);
    }

    public static string StripTagsRegex(string source)
    {
        return Regex.Replace(source, "<.*?>", string.Empty);
    }

    public static string StripTagsRegexCompiled(string source)
    {
        return _htmlRegex.Replace(source, string.Empty);
    }
}

