﻿namespace NAVPopup
{
    using NAVPopup.Properties;
    using System;
    using System.ComponentModel;
    using System.Diagnostics;
    using System.Drawing;
    using System.Windows.Forms;

    public class NAVPopup : Form
    {
        private IContainer components = null;
        private bool fadeIn;
        private Timer fadeTimer;
        private TransparentPanel panel1;
        private PictureBox pictureBox1;
        public string PopupText;
        public int position;
        private TextBox textBox1;
        private int timeDisplayed;
        public int uniqueID;
        public string URL;

        public NAVPopup()
        {
            this.InitializeComponent();
            base.Opacity = 0.0;
            this.pictureBox1.Image = Resources.Dynamics_Logo;
            this.fadeIn = true;
            this.fadeTimer = new Timer();
            this.fadeTimer.Interval = 10;
            this.fadeTimer.Tick += new EventHandler(this.fadeTimer_Tick);
            this.fadeTimer.Start();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void fadeTimer_Tick(object sender, EventArgs e)
        {
            try
            {
                if (this.MouseInWindowArea())
                {
                    base.Opacity = 1.0;
                    this.timeDisplayed = 0;
                }
                else if (this.fadeIn)
                {
                    if (base.Opacity == 1.0)
                    {
                        this.fadeIn = false;
                    }
                    else
                    {
                        base.Opacity += 0.01;
                    }
                }
                else if (this.timeDisplayed < 0x1388)
                {
                    this.timeDisplayed += this.fadeTimer.Interval;
                }
                else if (base.Opacity == 0.0)
                {
                    this.fadeTimer.Stop();
                    base.Close();
                }
                else
                {
                    base.Opacity -= 0.01;
                }
            }
            catch (Exception)
            {
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.UpdateLocation();
            this.Text = "Microsoft Dynamics NAV";
            this.textBox1.Select(0, 0);
            this.panel1.Focus();
        }

        private void InitializeComponent()
        {
            this.textBox1 = new TextBox();
            this.panel1 = new TransparentPanel();
            this.pictureBox1 = new PictureBox();
            ((ISupportInitialize) this.pictureBox1).BeginInit();
            base.SuspendLayout();
            this.textBox1.BackColor = Color.White;
            this.textBox1.BorderStyle = BorderStyle.None;
            this.textBox1.Location = new Point(0x34, 0);
            this.textBox1.Multiline = true;
            this.textBox1.Name = "textBox1";
            this.textBox1.ReadOnly = true;
            this.textBox1.Size = new Size(0xc6, 0x5f);
            this.textBox1.TabIndex = 0;
            this.textBox1.MouseDoubleClick += new MouseEventHandler(this.NAVPopup_MouseDoubleClick);
            this.panel1.Location = new Point(0x34, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new Size(0xc6, 0x5f);
            this.panel1.TabIndex = 1;
            this.panel1.MouseDoubleClick += new MouseEventHandler(this.NAVPopup_MouseDoubleClick);
            this.pictureBox1.Location = new Point(3, 3);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new Size(0x2b, 0x29);
            this.pictureBox1.TabIndex = 2;
            this.pictureBox1.TabStop = false;
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.BackColor = Color.White;
            base.ClientSize = new Size(0xf9, 0x5e);
            base.Controls.Add(this.pictureBox1);
            base.Controls.Add(this.panel1);
            base.Controls.Add(this.textBox1);
            base.FormBorderStyle = FormBorderStyle.FixedToolWindow;
            base.Name = "NAVPopup";
            base.TopMost = true;
            base.Load += new EventHandler(this.Form1_Load);
            base.MouseDoubleClick += new MouseEventHandler(this.NAVPopup_MouseDoubleClick);
            ((ISupportInitialize) this.pictureBox1).EndInit();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private bool MouseInWindowArea()
        {
            return ((((Cursor.Position.X >= base.Location.X) && (Cursor.Position.X <= (base.Location.X + base.Width))) && (Cursor.Position.Y >= base.Location.Y)) && (Cursor.Position.Y <= (base.Location.Y + base.Height)));
        }

        public void MoveDown()
        {
            this.position--;
            this.UpdateLocation();
        }

        private void NAVPopup_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            Process.Start(this.URL);
            base.Dispose();
        }

        public void SetText()
        {
            this.textBox1.Text = this.PopupText;
        }

        public void ShowNote()
        {
            this.SetText();
            base.Show();
        }

        private void UpdateLocation()
        {
            Rectangle workingArea = Screen.GetWorkingArea(this);
            if (Screen.GetWorkingArea(this).Top > 0)
            {
                base.Location = new Point((workingArea.Width - base.Width) - 2, workingArea.Top);
            }
            else if (this.position == 1)
            {
                base.Location = new Point((workingArea.Width - base.Width) - 8, ((workingArea.Height - (base.Height * this.position)) - 2) + workingArea.Top);
            }
            else
            {
                base.Location = new Point((workingArea.Width - base.Width) - 8, ((workingArea.Height - ((base.Height + 12) * this.position)) + 10) + workingArea.Top);
            }
        }
    }
}

