﻿namespace WpfRichText.Ex.Controls
{
    using System;
    using System.ComponentModel;
    using System.Diagnostics;
    using System.Windows;
    using System.Windows.Controls;
    using System.Windows.Markup;

    public class RichTextEditor : UserControl, IComponentConnector
    {
        private bool _contentLoaded;
        internal DockPanel mainPanel;
        internal RichTextBox mainRTB;
        public static readonly DependencyProperty TextProperty = DependencyProperty.Register("Text", typeof(string), typeof(RichTextEditor), new PropertyMetadata(string.Empty));
        internal RichTextEditor uxRichTextEditor;

        public RichTextEditor()
        {
            this.InitializeComponent();
        }

        [DebuggerNonUserCode]
        internal Delegate _CreateDelegate(Type delegateType, string handler)
        {
            return Delegate.CreateDelegate(delegateType, this, handler);
        }

        [DebuggerNonUserCode]
        public void InitializeComponent()
        {
            if (!this._contentLoaded)
            {
                this._contentLoaded = true;
                Uri resourceLocator = new Uri("/NAVEnhancedNotesCustomControls;component/controls/richtexteditor.xaml", UriKind.Relative);
                Application.LoadComponent(this, resourceLocator);
            }
        }

        [EditorBrowsable(EditorBrowsableState.Never), DebuggerNonUserCode]
        void IComponentConnector.Connect(int connectionId, object target)
        {
            switch (connectionId)
            {
                case 1:
                    this.uxRichTextEditor = (RichTextEditor) target;
                    break;

                case 2:
                    this.mainPanel = (DockPanel) target;
                    break;

                case 3:
                    this.mainRTB = (RichTextBox) target;
                    break;

                default:
                    this._contentLoaded = true;
                    break;
            }
        }

        public string Text
        {
            get
            {
                return (base.GetValue(TextProperty) as string);
            }
            set
            {
                base.SetValue(TextProperty, value);
            }
        }
    }
}

